#ifndef  SOFTWARE_I2C_H
#define  SOFTWARE_I2C_H
//------------------------------------------------------------------------------
#include "Software_i2c_Pins.h"
#include "software_i2c_Prototypes.h"
//------------------------------------------------------------------------------
void softI2C_init()
{
  //Make SDA and SCK pins input initially
  SDA = 1;
  SCK = 1;
}
//------------------------------------------------------------------------------
void I2C_start()
{
  //Function Purpose: I2C_Start sends start bit sequence
  SCK = 1;
  SDA = 1;
  __delay_ms(DLY);
  SDA = 0;
}
//------------------------------------------------------------------------------
void I2C_restart()
{
  //Function Purpose: I2C_ReStart sends start bit sequence
  SCK = 0;
  __delay_ms(DLY);
  SDA = 1;
  __delay_ms(DLY);
  SCK = 1;
  __delay_ms(DLY);
  SDA = 0;
}
//------------------------------------------------------------------------------
void I2C_stop()
{
  //Function : I2C_Stop sends stop bit sequence
  SCK = 0;
  SDA = 0;
  __delay_ms(DLY);
  SCK = 1;
  __delay_ms(DLY);
  SDA = 1;
}
//------------------------------------------------------------------------------
void I2C_ack(char ackn)
{
  //Function : I2C_Send_ACK sends ACK bit sequence
  SCK = 0;
  SDA = ackn;
  __delay_ms(DLY);
  SCK = 1;
}
//------------------------------------------------------------------------------
char I2C_write(char data)
{
  //Function Purpose: I2C_Write_Byte transfers one byte
  for(char tx = 0 ; tx < 8 ; tx++ )
  {
    SCK = 0;
    SDA = ((data << tx) & 0x80) ? 1 : 0 ; //MSB first
    SCK = 1;                   //Toggle SCK pin So that slave can latch data bit
  }
  I2C_ack(ACK);

  return SDA_DATA;
}
//------------------------------------------------------------------------------
 char I2C_read(char ackState)
{
  //Function Purpose: I2C_Read_Byte reads one byte
  char data = 0;
  for(char rx = 0 ; rx < 8 ; rx++ )
  {
    I2C_ack(NACK);
    data += ( SDA_DATA << (7-rx) );
  }
  
  I2C_ack(ackState);
  
  return data;
}
//------------------------------------------------------------------------------
#endif